package com.liang.service;

import com.liang.common.base.BaseResult;
import com.liang.entity.FeeManagemant;
import com.liang.entity.PrjProject;
import com.liang.entity.PrjProjects;
import com.liang.entity.StaBudgetapproval;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * 项目(PrjProject)表服务接口
 *
 * @author makejava
 * @since 2023-03-08 14:54:54
 */
public interface PrjProjectService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjProject queryById(Integer id);

    /**
     * 分页查询
     *
     * @param prjProject  筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<PrjProject> queryByPage(PrjProject prjProject, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjProject 实例对象
     * @return 实例对象
     */
    int insert(PrjProject prjProject);

    /**
     * 新增数据（基本信息）
     *
     * @param project 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(PrjProject project);

    /**
     * 新增数据（基本信息）
     *
     * @param prjProject 实例对象
     * @return 影响行数
     */
    int insertNormal(PrjProject prjProject);

    /**
     * 修改数据
     *
     * @param prjProject 实例对象
     * @return 实例对象
     */
    int update(PrjProject prjProject);

    /**
     * 修改数据(基本信息)
     *
     * @param prjProject 实例对象
     * @return 影响行数
     */
    int updateNormal(PrjProject prjProject);

    /**
     * 更新填写说明
     *
     * @return
     */
    int updateTXSM(String txsm, Integer id);

    /**
     * 更新研究内容及考核指标
     *
     * @return
     */
    int updateContent(String yjnrjkhzb, Integer id);

    /**
     * 更新有关问题说明
     *
     * @return
     */
    int updateYGWTSM(String ygwtsm, Integer id);

    /**
     * 更新附件
     *
     * @return
     */
    int updateFJ(String fj, Integer id);

    /**
     * 修改审批状态
     *
     * @param project 实例对象
     * @return 实例对象
     */
    int updateSpzt(PrjProject project);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 获取项目
     *
     * @return
     */
    List<PrjProject> getProjectList(Map map);

    /**
     * 获取项目
     *
     * @return
     */
    List<PrjProject> getNdysProjectList(Map map);

    List<PrjProject> getByjProjectList(Map map);

    /**
     * 批量删除项目任务书
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 获取项目任务书
     *
     * @return
     */
    List<PrjProject> getRwsList(Map map);

    /**
     * 获取费用管理列表
     *
     * @return
     */
    List<FeeManagemant> getFyglList(Map map);

    BaseResult updatePrj_AnnualBudgetDetail(Integer rws);


    List<PrjProject> getErpBh(String erpBh);


    void updateSPTGZT(PrjProject rws);
    void updateSPTGZT1(Integer rws);

    void updateSFXG(Integer xmid);


    int updateZy(PrjProjects prjProjects);
}
